unsigned char prev;
unsigned char current;
unsigned long c_time;
unsigned long p_time;
unsigned long d_time;
unsigned char prev_code;
unsigned long prev_fallingedge;

void setup() {
  p_time = 0;
  prev_code = '0';
  pinMode(7,INPUT);
  Serial.begin( 9600 );
}

void loop() {
  current = digitalRead( 7 );    
  if( prev != current ) {
    c_time = millis();
    if( current == HIGH ) {
      d_time = c_time - p_time;
      if( d_time < 350 ) {
        if( prev_code == 'M' ) {
          Serial.println( "" );
        }
        Serial.print( "M" );
        prev_code = 'M';
      } else if( d_time < 650 ) {
        Serial.print( "1" );
        prev_code = '1';
      } else {
        Serial.print( "0" );
        prev_code = '0';        
      }        
    } else {
      if( c_time < (prev_fallingedge + 1000 - 50) || (prev_fallingedge + 1000 + 50) < c_time ) {
        Serial.print( "E" );
      }
      prev_fallingedge = c_time;
    }  
  }     
  prev = current; 
  p_time = c_time; 
}
